
class Action(object):
    def __init__(self, node, **kw):
        self.volume = 1.0
        self.duration = 1.0
        self.node = node
        self.__dict__.update(kw)
    
    def execute(self):
        self.act()

class Play(Action):
    def act(self):
        self.node.set_volume(self.volume)
        self.node.play()
        
class Stop(Action):
    def act(self):
        self.node.stop()
        
class Volume(Action):
    def act(self):
        self.node.set_volume(self.volume)
        
class FadeOut(Action):
    def act(self):
        self.node.fadeout(int(self.duration*1000))
        