from math import cos, sin, atan, pi, hypot, acos, degrees, radians

class Vector(tuple):
    x = property(lambda self: self[0])
    y = property(lambda self: self[1])
    magnitude = property(lambda self: hypot(self[0], self[1]))
    unit = property(lambda self: self  / self.magnitude)

    def int(self):
        return Vector([int(i) for i in self])

    def float(self):
        return Vector([float(i) for i in self])

    def dot_product(self, vector):
        return sum([x*y for x,y in zip(self, vector)])

    def __add__(self, vector):
        return Vector([x+y for x,y in zip(self, vector)])

    def __sub__(self, vector):
        return Vector([x-y for x,y in zip(self, vector)])

    def __div__(self, scalar):
        return Vector([x/scalar for x in self])

    def __mul__(self, scalar):
        return Vector([x*scalar for x in self])

    def angle(self):
        x,y = float(self[0]),float(self[1])
        if x > 0:
            if y >= 0: return degrees(atan(y / x))
            else: return degrees((atan(y / x) + (2*pi)))
        elif x == 0:
            if y > 0: return degrees((0.5 * pi))
            elif y == 0: return 0
            else: return degrees((1.5*pi))
        else:
            return degrees((atan(y / x) + pi))

def polar_vector(angle, magnitude):
    angle = radians(angle)
    return Vector((magnitude * cos(angle), magnitude * sin(angle)))


if __name__ == "__main__":
    t = Vector((92,32,4.1))
    print t.unit
    print t.dot_product((1,2,3))


















